sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=96
left=51
tile=1
caption="Text: Stile, Fonts & Grsse"
tileSpacing=6
End CompInit
Dim group2 as group
group2 = MakeComponent("group",form1)
CompInit group2
proto="group2"
caption=""
look=1
tile=1
tileLayout=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Dim text1 as text
text1 = MakeComponent("text",group2)
CompInit text1
proto="text1"
look=3
maxLines=6
width=322
height=70
End CompInit
text1.name="text1"
text1.AppendString("Test fr Text-Objekt. Um den Stil zu ndern, aktiviere die entsprechende Auswahl. Entsprechend  bei der Schriftart, Grsse und den Farben.")
text1.visible=1
Dim scrollbar1 as scrollbar
scrollbar1 = MakeComponent("scrollbar",group2)
CompInit scrollbar1
proto="scrollbar1"
sizeVControl=0
sizeHControl=3
notifyDrag=1
height=73
visible=1
End CompInit
scrollbar1.name="scrollbar1"
group2.name="group2"
Dim auswahl_group as group
auswahl_group = MakeComponent("group",form1)
CompInit auswahl_group
proto="auswahl_group"
caption=""
look=1
tile=1
tileLayout=1
visible=1
End CompInit
Dim group1 as group
group1 = MakeComponent("group",auswahl_group)
CompInit group1
proto="group1"
caption="Textstil"
look=1
tile=1
sizeVControl=0
height=61
tileHAlign=2
sizeHControl=3
visible=1
End CompInit
Dim u_toggle as toggle
u_toggle = MakeComponent("toggle",group1)
CompInit u_toggle
proto="u_toggle"
caption="Unterstrichen"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
u_toggle.name="u_toggle"
Dim d_toggle as toggle
d_toggle = MakeComponent("toggle",group1)
CompInit d_toggle
proto="d_toggle"
caption="Durchgestrichen"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
d_toggle.name="d_toggle"
Dim t_toggle as toggle
t_toggle = MakeComponent("toggle",group1)
CompInit t_toggle
proto="t_toggle"
caption="Tiefgestellt"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
t_toggle.name="t_toggle"
Dim h_toggle as toggle
h_toggle = MakeComponent("toggle",group1)
CompInit h_toggle
proto="h_toggle"
caption="Hochgestellt"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
h_toggle.name="h_toggle"
Dim k_toggle as toggle
k_toggle = MakeComponent("toggle",group1)
CompInit k_toggle
proto="k_toggle"
caption="Kursiv"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
k_toggle.name="k_toggle"
Dim f_toggle as toggle
f_toggle = MakeComponent("toggle",group1)
CompInit f_toggle
proto="f_toggle"
caption="Fett"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
f_toggle.name="f_toggle"
Dim n_toggle as toggle
n_toggle = MakeComponent("toggle",group1)
CompInit n_toggle
proto="n_toggle"
caption="Normal"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
n_toggle.name="n_toggle"
group1.name="group1"
Dim group3 as group
group3 = MakeComponent("group",auswahl_group)
CompInit group3
proto="group3"
caption="Schriften"
look=1
sizeHControl=3
sizeVControl=3
tile=1
tileHAlign=2
visible=1
End CompInit
Dim fm_choice as choice
fm_choice = MakeComponent("choice",group3)
CompInit fm_choice
proto="fm_choice"
caption="URW Mono"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
fm_choice.name="fm_choice"
Dim fs_choice as choice
fs_choice = MakeComponent("choice",group3)
CompInit fs_choice
proto="fs_choice"
caption="URW Sans"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
fs_choice.name="fs_choice"
Dim fc_choice as choice
fc_choice = MakeComponent("choice",group3)
CompInit fc_choice
proto="fc_choice"
caption="Cooperstown"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
fc_choice.name="fc_choice"
Dim fcb_choice as choice
fcb_choice = MakeComponent("choice",group3)
CompInit fcb_choice
proto="fcb_choice"
caption="Cranbrook"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
fcb_choice.name="fcb_choice"
Dim fsb_choice as choice
fsb_choice = MakeComponent("choice",group3)
CompInit fsb_choice
proto="fsb_choice"
caption="Superb"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
fsb_choice.name="fsb_choice"
Dim fsa_choice as choice
fsa_choice = MakeComponent("choice",group3)
CompInit fsa_choice
proto="fsa_choice"
caption="Shattuck Avenue"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
fsa_choice.name="fsa_choice"
Dim fr_choice as choice
fr_choice = MakeComponent("choice",group3)
CompInit fr_choice
proto="fr_choice"
caption="URW Roman"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
fr_choice.name="fr_choice"
group3.name="group3"
Dim g_group as group
g_group = MakeComponent("group",auswahl_group)
CompInit g_group
proto="g_group"
caption="Grsse"
look=1
sizeHControl=3
sizeVControl=3
tile=1
tileHAlign=2
visible=1
End CompInit
Dim g8_choice as choice
g8_choice = MakeComponent("choice",g_group)
CompInit g8_choice
proto="g8_choice"
caption="8 pt"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
g8_choice.name="g8_choice"
Dim g10_choice as choice
g10_choice = MakeComponent("choice",g_group)
CompInit g10_choice
proto="g10_choice"
caption="10 pt"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
g10_choice.name="g10_choice"
Dim g12_choice as choice
g12_choice = MakeComponent("choice",g_group)
CompInit g12_choice
proto="g12_choice"
caption="12 pt"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
g12_choice.name="g12_choice"
Dim g15_choice as choice
g15_choice = MakeComponent("choice",g_group)
CompInit g15_choice
proto="g15_choice"
caption="15 pt"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
g15_choice.name="g15_choice"
Dim g20_choice as choice
g20_choice = MakeComponent("choice",g_group)
CompInit g20_choice
proto="g20_choice"
caption="20 pt"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
g20_choice.name="g20_choice"
Dim g25_choice as choice
g25_choice = MakeComponent("choice",g_group)
CompInit g25_choice
proto="g25_choice"
caption="25 pt"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
g25_choice.name="g25_choice"
Dim g30_choice as choice
g30_choice = MakeComponent("choice",g_group)
CompInit g30_choice
proto="g30_choice"
caption="30 pt"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
g30_choice.name="g30_choice"
g_group.name="g_group"
auswahl_group.name="auswahl_group"
Dim tv_group as group
tv_group = MakeComponent("group",form1)
CompInit tv_group
proto="tv_group"
caption="Textfarbe"
look=1
tileLayout=1
tile=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Dim trot_choice as choice
trot_choice = MakeComponent("choice",tv_group)
CompInit trot_choice
proto="trot_choice"
caption="Rot         "
sizeHControl=3
sizeVControl=3
look=1
visible=1
End CompInit
trot_choice.name="trot_choice"
Dim tgruen_choice as choice
tgruen_choice = MakeComponent("choice",tv_group)
CompInit tgruen_choice
proto="tgruen_choice"
caption="Grn      "
sizeHControl=3
sizeVControl=3
look=1
visible=1
End CompInit
tgruen_choice.name="tgruen_choice"
Dim tgelb_choice as choice
tgelb_choice = MakeComponent("choice",tv_group)
CompInit tgelb_choice
proto="tgelb_choice"
caption="Gelb       "
look=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
tgelb_choice.name="tgelb_choice"
Dim tblau_choice as choice
tblau_choice = MakeComponent("choice",tv_group)
CompInit tblau_choice
proto="tblau_choice"
caption="Blau       "
look=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
tblau_choice.name="tblau_choice"
Dim torange_choice as choice
torange_choice = MakeComponent("choice",tv_group)
CompInit torange_choice
proto="torange_choice"
caption="Cyan      "
look=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
torange_choice.name="torange_choice"
Dim tschwarz_choice as choice
tschwarz_choice = MakeComponent("choice",tv_group)
CompInit tschwarz_choice
proto="tschwarz_choice"
caption="Schwarz"
sizeHControl=3
sizeVControl=3
status=1
look=1
visible=1
End CompInit
tschwarz_choice.name="tschwarz_choice"
tv_group.name="tv_group"
Dim th_group as group
th_group = MakeComponent("group",form1)
CompInit th_group
proto="th_group"
caption="Texthintergrundfarbe"
look=1
tile=1
tileLayout=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Dim brot_choice as choice
brot_choice = MakeComponent("choice",th_group)
CompInit brot_choice
proto="brot_choice"
caption="Rot        "
look=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
brot_choice.name="brot_choice"
Dim bgruen_choice as choice
bgruen_choice = MakeComponent("choice",th_group)
CompInit bgruen_choice
proto="bgruen_choice"
caption="Grn      "
look=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
bgruen_choice.name="bgruen_choice"
Dim bgelb_choice as choice
bgelb_choice = MakeComponent("choice",th_group)
CompInit bgelb_choice
proto="bgelb_choice"
caption="Purpur   "
look=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
bgelb_choice.name="bgelb_choice"
Dim bblau_choice as choice
bblau_choice = MakeComponent("choice",th_group)
CompInit bblau_choice
proto="bblau_choice"
caption="Blau       "
look=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
bblau_choice.name="bblau_choice"
Dim bbraun_choice as choice
bbraun_choice = MakeComponent("choice",th_group)
CompInit bbraun_choice
proto="bbraun_choice"
caption="Braun     "
look=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
bbraun_choice.name="bbraun_choice"
Dim bweiss_choice as choice
bweiss_choice = MakeComponent("choice",th_group)
CompInit bweiss_choice
proto="bweiss_choice"
caption="Weiss     "
look=1
status=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
bweiss_choice.name="bweiss_choice"
th_group.name="th_group"
form1.width=388
form1.height=369
form1.name="form1"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

text1.font = "URW Mono"
text1.fontSize = 15

scrollbar1.orientation = 1
scrollbar1.look = 1

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub u_toggle_changed(self as toggle)
	n_toggle.status = 0
	StilUpdate()
end sub

sub d_toggle_changed(self as toggle)
	n_toggle.status = 0
	StilUpdate()
end sub

sub t_toggle_changed(self as toggle)
	n_toggle.status = 0
	h_toggle.status = 0
	StilUpdate()
end sub

sub h_toggle_changed(self as toggle)
	n_toggle.status = 0
	t_toggle.status = 0
	StilUpdate()
end sub

sub k_toggle_changed(self as toggle)
	n_toggle.status = 0
	StilUpdate()
end sub

sub f_toggle_changed(self as toggle)
	n_toggle.status = 0
	StilUpdate()
end sub

sub fm_choice_changed(self as choice)
	text1.font = "URW Mono"
	StilUpdate()
end sub

sub fs_choice_changed(self as choice)
	text1.font = "URW Sans"
	StilUpdate()
end sub

sub fc_choice_changed(self as choice)
	text1.font = "Cooperstown"
	StilUpdate()
end sub

sub g10_choice_changed(self as choice)
	text1.fontSize = 10
	StilUpdate()
end sub

sub g15_choice_changed(self as choice)
	text1.fontSize = 15
	StilUpdate()
end sub

sub g20_choice_changed(self as choice)
	text1.fontSize = 20
	StilUpdate()
end sub

sub StilUpdate()

rem Funktion wird zur Auswertung der Stil-Toggle und
rem Kombination derer gebraucht (toggleX.status)

dim stildummy as integer

if u_toggle.status = 1
	stildummy = stildummy BITOR 1
end if

if d_toggle.status = 1
	stildummy = stildummy BITOR 2
end if
if k_toggle.status = 1
	stildummy = stildummy BITOR 16
end if
if f_toggle.status = 1
	stildummy = stildummy BITOR 32
end if

if t_toggle.status = 1
		stildummy = stildummy BITOR 4
end if

if h_toggle.status = 1
		stildummy = stildummy BITOR 8
end if

if stildummy = 0
	n_toggle.status = 1
end if

text1.fontStyle = stildummy
group1.caption = "Textstil ("+str(stildummy)+")"

if IsNullComponent(fm_choice.choice) > 0
	fm_choice.status = 1
	fm_choice_changed(fm_choice)
end if

if IsNullComponent(g15_choice.choice) > 0
	g15_choice.status = 1
	g15_choice_changed(g15_choice)
end if

end sub

sub fsa_choice_changed(self as choice)
	text1.font = "Shattuck Avenue"
	StilUpdate()
end sub

sub fsb_choice_changed(self as choice)
	text1.font = "Superb"
	StilUpdate()
end sub

sub fcb_choice_changed(self as choice)
	text1.font = "Cranbrook"
	StilUpdate()
end sub

sub g8_choice_changed(self as choice)
	text1.fontSize = 8
	StilUpdate()
end sub

sub g12_choice_changed(self as choice)
	text1.fontSize = 12
	StilUpdate()
end sub

sub g25_choice_changed(self as choice)
	text1.fontSize = 25
	StilUpdate()
end sub

sub g30_choice_changed(self as choice)
	text1.fontSize = 30
	StilUpdate()
end sub

sub fr_choice_changed(self as choice)
	text1.font = "URW Roman"
	StilUpdate()
end sub

sub n_toggle_changed(self as toggle)
	d_toggle.status = 0
	t_toggle.status = 0
	h_toggle.status = 0
	k_toggle.status = 0
	f_toggle.status = 0
	u_toggle.status = 0
	StilUpdate()
end sub

sub FarbUpdate()
	if trot_choice.status = 0 and tgruen_choice.status = 0 and tgelb_choice.status = 0 and tblau_choice.status = 0 and torange_choice.status = 0 and tschwarz_choice.status = 0
		tschwarz_choice.status = 1
		text1.color = BLACK
	end if
	
	if brot_choice.status = 0 and bgruen_choice.status = 0 and bgelb_choice.status = 0 and bblau_choice.status = 0 and bbraun_choice.status = 0 and bweiss_choice.status = 0
		bweiss_choice.status = 1
		text1.bgColor = WHITE
	end if
end sub

sub trot_choice_changed(self as choice)
	text1.color = DARK_RED
	FarbUpdate()
end sub

sub tgruen_choice_changed(self as choice)
	text1.color = DARK_GREEN
	FarbUpdate()
end sub

sub tgelb_choice_changed(self as choice)
	text1.color = YELLOW
	FarbUpdate()
end sub

sub tblau_choice_changed(self as choice)
	text1.color = DARK_BLUE
	FarbUpdate()
end sub

sub torange_choice_changed(self as choice)
	text1.color = DARK_CYAN
	FarbUpdate()
end sub

sub tschwarz_choice_changed(self as choice)
	text1.color = BLACK
	FarbUpdate()
end sub

sub brot_choice_changed(self as choice)
	text1.bgColor = LIGHT_RED
	FarbUpdate()
end sub

sub bgruen_choice_changed(self as choice)
	text1.bgColor = LIGHT_GREEN
	FarbUpdate()
end sub

sub bgelb_choice_changed(self as choice)
	text1.bgColor = LIGHT_PURPLE
	FarbUpdate()
end sub

sub bblau_choice_changed(self as choice)
	text1.bgColor = LIGHT_BLUE
	FarbUpdate()
end sub

sub bbraun_choice_changed(self as choice)
	text1.bgColor = BROWN
	FarbUpdate()
end sub

sub bweiss_choice_changed(self as choice)
	text1.bgColor = WHITE
	FarbUpdate()
end sub

sub text1_numLinesChanged(self as text)
	scrollbar1.maximum = self.numLines + int(text1.fontSize/3)
	scrollbar1.thumbSize = self.lastVisibleLine - self.firstVisibleLine + 1
end sub

sub text1_scrolled(self as text)
	scrollbar1.value = self.firstVisibleLine
end sub

sub scrollbar1_changed(self as scrollbar, scrollType as integer)
	text1.firstVisibleLine = self.value
end sub

