sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=94
left=99
sizeHControl=0
sizeVControl=0
tile=1
caption="Feiertage"
tileSpacing=5
End CompInit
Dim jahr_number as number
jahr_number = MakeComponent("number",form1)
CompInit jahr_number
proto="jahr_number"
caption="Jahr:"
sizeHControl=3
sizeVControl=3
value=1998
minimum=1901
maximum=2099
visible=1
End CompInit
jahr_number.name="jahr_number"
Dim group2 as group
group2 = MakeComponent("group",form1)
CompInit group2
proto="group2"
caption=""
look=1
tile=1
tileLayout=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Dim group1 as group
group1 = MakeComponent("group",group2)
CompInit group1
proto="group1"
caption=""
look=1
tile=1
sizeHControl=3
sizeVControl=3
tileHAlign=3
visible=1
End CompInit
Dim label1 as label
label1 = MakeComponent("label",group1)
CompInit label1
proto="label1"
caption="label1"
visible=1
End CompInit
label1.name="label1"
Dim label2 as label
label2 = MakeComponent("label",group1)
CompInit label2
proto="label2"
caption="label2"
visible=1
End CompInit
label2.name="label2"
Dim label3 as label
label3 = MakeComponent("label",group1)
CompInit label3
proto="label3"
caption="label3"
visible=1
End CompInit
label3.name="label3"
Dim label4 as label
label4 = MakeComponent("label",group1)
CompInit label4
proto="label4"
caption="label4"
visible=1
End CompInit
label4.name="label4"
Dim label5 as label
label5 = MakeComponent("label",group1)
CompInit label5
proto="label5"
caption="label5"
visible=1
End CompInit
label5.name="label5"
Dim label6 as label
label6 = MakeComponent("label",group1)
CompInit label6
proto="label6"
caption="label6"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label6.name="label6"
Dim label7 as label
label7 = MakeComponent("label",group1)
CompInit label7
proto="label7"
caption="label7"
visible=1
End CompInit
label7.name="label7"
Dim label8 as label
label8 = MakeComponent("label",group1)
CompInit label8
proto="label8"
caption="label8"
visible=1
End CompInit
label8.name="label8"
Dim label9 as label
label9 = MakeComponent("label",group1)
CompInit label9
proto="label9"
caption="label9"
visible=1
End CompInit
label9.name="label9"
Dim label10 as label
label10 = MakeComponent("label",group1)
CompInit label10
proto="label10"
caption="label10"
visible=1
End CompInit
label10.name="label10"
Dim label11 as label
label11 = MakeComponent("label",group1)
CompInit label11
proto="label11"
caption="label11"
visible=1
End CompInit
label11.name="label11"
Dim label12 as label
label12 = MakeComponent("label",group1)
CompInit label12
proto="label12"
caption="label12"
visible=1
End CompInit
label12.name="label12"
Dim label13 as label
label13 = MakeComponent("label",group1)
CompInit label13
proto="label13"
caption="label13"
visible=1
End CompInit
label13.name="label13"
Dim label14 as label
label14 = MakeComponent("label",group1)
CompInit label14
proto="label14"
caption="label14"
visible=1
End CompInit
label14.name="label14"
Dim label15 as label
label15 = MakeComponent("label",group1)
CompInit label15
proto="label15"
caption="label15"
visible=1
End CompInit
label15.name="label15"
Dim label16 as label
label16 = MakeComponent("label",group1)
CompInit label16
proto="label16"
caption="label16"
visible=1
End CompInit
label16.name="label16"
Dim label17 as label
label17 = MakeComponent("label",group1)
CompInit label17
proto="label17"
caption="label17"
visible=1
End CompInit
label17.name="label17"
Dim label18 as label
label18 = MakeComponent("label",group1)
CompInit label18
proto="label18"
caption="label18"
visible=1
End CompInit
label18.name="label18"
group1.name="group1"
Dim group3 as group
group3 = MakeComponent("group",group2)
CompInit group3
proto="group3"
caption=""
look=1
tile=1
sizeHControl=3
sizeVControl=3
tileHAlign=3
visible=1
End CompInit
Dim label19 as label
label19 = MakeComponent("label",group3)
CompInit label19
proto="label19"
caption="label19"
visible=1
End CompInit
label19.name="label19"
Dim label20 as label
label20 = MakeComponent("label",group3)
CompInit label20
proto="label20"
caption="label20"
visible=1
End CompInit
label20.name="label20"
Dim label21 as label
label21 = MakeComponent("label",group3)
CompInit label21
proto="label21"
caption="label21"
visible=1
End CompInit
label21.name="label21"
Dim label22 as label
label22 = MakeComponent("label",group3)
CompInit label22
proto="label22"
caption="label22"
visible=1
End CompInit
label22.name="label22"
Dim label23 as label
label23 = MakeComponent("label",group3)
CompInit label23
proto="label23"
caption="label23"
visible=1
End CompInit
label23.name="label23"
Dim label24 as label
label24 = MakeComponent("label",group3)
CompInit label24
proto="label24"
caption="label24"
visible=1
End CompInit
label24.name="label24"
Dim label25 as label
label25 = MakeComponent("label",group3)
CompInit label25
proto="label25"
caption="label25"
visible=1
End CompInit
label25.name="label25"
Dim label26 as label
label26 = MakeComponent("label",group3)
CompInit label26
proto="label26"
caption="label26"
visible=1
End CompInit
label26.name="label26"
Dim label27 as label
label27 = MakeComponent("label",group3)
CompInit label27
proto="label27"
caption="label27"
visible=1
End CompInit
label27.name="label27"
Dim label28 as label
label28 = MakeComponent("label",group3)
CompInit label28
proto="label28"
caption="label28"
visible=1
End CompInit
label28.name="label28"
Dim label29 as label
label29 = MakeComponent("label",group3)
CompInit label29
proto="label29"
caption="label29"
visible=1
End CompInit
label29.name="label29"
Dim label30 as label
label30 = MakeComponent("label",group3)
CompInit label30
proto="label30"
caption="label30"
visible=1
End CompInit
label30.name="label30"
Dim label31 as label
label31 = MakeComponent("label",group3)
CompInit label31
proto="label31"
caption="label31"
visible=1
End CompInit
label31.name="label31"
Dim label32 as label
label32 = MakeComponent("label",group3)
CompInit label32
proto="label32"
caption="label32"
visible=1
End CompInit
label32.name="label32"
Dim label33 as label
label33 = MakeComponent("label",group3)
CompInit label33
proto="label33"
caption="label33"
visible=1
End CompInit
label33.name="label33"
Dim label34 as label
label34 = MakeComponent("label",group3)
CompInit label34
proto="label34"
caption="label34"
visible=1
End CompInit
label34.name="label34"
Dim label35 as label
label35 = MakeComponent("label",group3)
CompInit label35
proto="label35"
caption="label35"
visible=1
End CompInit
label35.name="label35"
Dim label36 as label
label36 = MakeComponent("label",group3)
CompInit label36
proto="label36"
caption=""
height=12
sizeHControl=3
visible=1
End CompInit
label36.name="label36"
group3.name="group3"
group2.name="group2"
form1.width=320
form1.height=294
form1.name="form1"
Dim timedate1 as timedate
timedate1 = MakeComponent("timedate","app")
CompInit timedate1
proto="timedate1"
End CompInit
timedate1.name="timedate1"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

jahr_number_changed(jahr_number, 1998)

dim ost as integer ' OsterSonnTag
dim osm as integer ' OsterSonntagMonat
dim omt as integer ' OsterMonTag
dim omm as integer ' OsterMontagMonat

dim pst as integer ' PfingstSonnTag
dim psm as integer ' PfingstSonntagMonat
dim pmt as integer ' PfingstMonTag
dim pmm as integer ' PfingstMontagMonat

dim cht as integer ' ChristiHimmelfahrtTag
dim chm as integer ' ChristiHimmelfahtstagMonat

dim flt as integer ' Fronleichnam-Tag
dim flm as integer ' Fronleichnam-Monat

dim advent1t as integer ' 1. - 4. Advent
dim advent1m as integer
dim advent2  as integer
dim advent3  as integer
dim advent4  as integer

dim vt as integer ' Volkstrauertag
dim vm as integer

dim bt as integer ' Buss- und Bettag
dim bm as integer

dim tst as integer ' Totensonntag
dim tsm as integer

dim gdt as integer ' Gruendonnerstag
dim gdm as integer

dim kft as integer ' Karfreitag
dim kfm as integer

dim at as integer ' Aschermittwoch
dim am as integer

dim ft as integer ' Faschingsdienstag
dim fm as integer

dim rt as integer ' Rosenmontag
dim rm as integer

dim mt as integer ' Muttertag
dim mm as integer

dim et as integer ' Erntedankfest
dim em as integer

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub jahr_number_changed(self as number, value as integer)

group1.visible = 0
group3.visible = 0

Ostern()
Weihnachten()

dim dows[8] as string

dows[0] = "So"
dows[1] = "Mo"
dows[2] = "Di"
dows[3] = "Mi"
dows[4] = "Do"
dows[5] = "Fr"
dows[6] = "Sa"

label1.caption  = dows[timedate1.GetDayOfWeek(jahr_number.value,  1,  1)]+", Neujahr: 01.01."+str(jahr_number.value)
label2.caption  = dows[timedate1.GetDayOfWeek(jahr_number.value,  1,  6)]+", Heilige drei Knige: 06.01."+str(jahr_number.value)
label3.caption  = dows[timedate1.GetDayOfWeek(jahr_number.value,  2, 14)]+", Valentinstag: 14.02."+str(jahr_number.value)
label17.caption = dows[timedate1.GetDayOfWeek(jahr_number.value,  8, 15)]+", Maria Himmelfahrt: 15.08."+str(jahr_number.value)
label18.caption = dows[timedate1.GetDayOfWeek(jahr_number.value, 10,  3)]+", Tag der deutschen Einheit: 03.10."+str(jahr_number.value)
label11.caption = dows[timedate1.GetDayOfWeek(jahr_number.value,  5,  1)]+", Maifeiertag: 01.05."+str(jahr_number.value)
label20.caption = dows[timedate1.GetDayOfWeek(jahr_number.value, 10, 31)]+", Reformationstag: 31.10."+str(jahr_number.value)
label21.caption = dows[timedate1.GetDayOfWeek(jahr_number.value, 11,  1)]+", Allerheiligen: 01.11."+str(jahr_number.value)
label22.caption = dows[timedate1.GetDayOfWeek(jahr_number.value, 11,  2)]+", Allerseelen: 02.11."+str(jahr_number.value)
label27.caption = dows[timedate1.GetDayOfWeek(jahr_number.value, 12,  6)]+", St. Nikolaus: 06.12."+str(jahr_number.value)
label32.caption = dows[timedate1.GetDayOfWeek(jahr_number.value, 12, 24)]+", Heiligabend: 24.12."+str(jahr_number.value)
label33.caption = dows[timedate1.GetDayOfWeek(jahr_number.value, 12, 25)]+", 1. Weihnachtsfeiertag: 25.12."+str(jahr_number.value)
label34.caption = dows[timedate1.GetDayOfWeek(jahr_number.value, 12, 26)]+", 2. Weihnachtsfeiertag: 26.12."+str(jahr_number.value)
label35.caption = dows[timedate1.GetDayOfWeek(jahr_number.value, 12, 31)]+", Silvester: 31.12."+str(jahr_number.value)
label29.caption = dows[timedate1.GetDayOfWeek(jahr_number.value, 12,  8)]+", Mari Empfngnis: 08.12."+str(jahr_number.value)

label13.caption = dows[timedate1.GetDayOfWeek(jahr_number.value, chm, cht)]+", Christi Himmelfahrt: "+CorrectString(str(cht))+"."+CorrectString(str(chm))+"."+str(jahr_number.value)
label16.caption = dows[timedate1.GetDayOfWeek(jahr_number.value, flm, flt)]+", Fronleichnam: "       +CorrectString(str(flt))+"."+CorrectString(str(flm))+"."+str(jahr_number.value)
label24.caption = dows[timedate1.GetDayOfWeek(jahr_number.value, bm,  bt)]+ ", Buss- und Bettag: "   +CorrectString(str(bt)) +"."+CorrectString(str(bm)) +"."+str(jahr_number.value)

label4.caption  = "Mo, Rosenmontag: "        +CorrectString(str(rt))      +"."   +CorrectString(str(rm))      +"."+str(jahr_number.value)
label5.caption  = "Di, Faschingsdienstag: "  +CorrectString(str(ft))      +"."   +CorrectString(str(fm))      +"."+str(jahr_number.value)
label6.caption  = "Mi, Aschermittwoch: "     +CorrectString(str(at))      +"."   +CorrectString(str(am))      +"."+str(jahr_number.value)
label7.caption  = "Do, Grndonnerstag: "     +CorrectString(str(gdt))     +"."   +CorrectString(str(gdm))     +"."+str(jahr_number.value)
label8.caption  = "Fr, Karfreitag: "         +CorrectString(str(kft))     +"."   +CorrectString(str(kfm))     +"."+str(jahr_number.value)
label9.caption  = "So, Ostersonntag: "       +CorrectString(str(ost))     +"."   +CorrectString(str(osm))     +"."+str(jahr_number.value)
label10.caption = "Mo, Ostermontag: "        +CorrectString(str(omt))     +"."   +CorrectString(str(omm))     +"."+str(jahr_number.value)
label14.caption = "So, Pfingstsonntag: "     +CorrectString(str(pst))     +"."   +CorrectString(str(psm))     +"."+str(jahr_number.value)
label15.caption = "Mo, Pfingstmontag: "      +CorrectString(str(pmt))     +"."   +CorrectString(str(pmm))     +"."+str(jahr_number.value)
label23.caption = "So, Volkstrauertag: "     +CorrectString(str(vt))      +"."   +CorrectString(str(vm))      +"."+str(jahr_number.value)
label25.caption = "So, Totensonntag: "       +CorrectString(str(tst))     +"."   +CorrectString(str(tsm))     +"."+str(jahr_number.value)
label26.caption = "So, 1. Advent: "          +CorrectString(str(advent1t))+"."   +CorrectString(str(advent1m))+"."+str(jahr_number.value)
label28.caption = "So, 2. Advent: "          +CorrectString(str(advent2)) +".12."+str(jahr_number.value)
label30.caption = "So, 3. Advent: "          +CorrectString(str(advent3)) +".12."+str(jahr_number.value)
label31.caption = "So, 4. Advent: "          +CorrectString(str(advent4)) +".12."+str(jahr_number.value)
label12.caption = "So, Muttertag: "          +CorrectString(str(mt))      +".05."+str(jahr_number.value)

label19.caption = "So, Erntedankfest: "+CorrectString(str(et))+"."+CorrectString(str(em))+"."+str(jahr_number.value)

group1.visible = 1
group3.visible = 1

end sub

sub Ostern()

' Ostersonntag (nach Carl Friedrich Gauss 1777-1855)

' ost - OsterSonnTag
' osm - OsterSonntagMonat
' omt - OsterMonTag
' omm - OsterMontagMonat

dim a as integer
dim b as integer
dim c as integer
dim d as integer
dim e as integer
dim j as integer

j = jahr_number.value
a = j mod 19
b = j mod 4
c = j mod 7
d = (19*a+24) mod 30
e = (2*b+4*c+6*d+5) mod 7
ost = 22+d+e
osm = 3

if ost > 31
	ost = d+e-9
	osm = 4
end if

if ost = 26 and osm = 4
	ost = 19
end if

if ost=25 and osm=4 and d=28 and e=6 and a=10
	ost = 18
end if

' Ostermontag - omt, omm

omt = ost + 1
omm = osm

if omt > timedate1.GetDaysInMonth(jahr_number.value, osm)
	omm = osm+1
	omt = omt - timedate1.GetDaysInMonth(jahr_number.value, osm)
end if

' Pfingsten
' pst - PfingstSonnTag
' psm - PfingstSonntagMonat
' pmt - PfingstMonTag
' pmm - PfingstMontagMonat

dim pfingsten as integer
pfingsten = ost + 49
pfingsten = pfingsten - timedate1.GetDaysInMonth(jahr_number.value, osm)

if pfingsten < timedate1.GetDaysInMonth(jahr_number.value, osm+1) or pfingsten = timedate1.GetDaysInMonth(jahr_number.value, osm+1)
	pst = pfingsten
	psm = osm+1
else
	pfingsten = pfingsten - timedate1.GetDaysInMonth(jahr_number.value, osm+1)
	pst = pfingsten
	psm = osm+2
end if

' Pfingstmontag - pmt, pmm

pmt = pst + 1
pmm = psm

if pmt > timedate1.GetDaysInMonth(jahr_number.value, psm)
	pmm = psm+1
	pmt = pmt - timedate1.GetDaysInMonth(jahr_number.value, psm)
end if


' Christi Himmelfahrt
' cht - ChristiHimmelfahrtTag
' chm - ChristiHimmelfahtstagMonat

dim himmel as integer
himmel = ost + 39
himmel = himmel - timedate1.GetDaysInMonth(jahr_number.value, osm)

if himmel < timedate1.GetDaysInMonth(jahr_number.value, osm+1) or himmel = timedate1.GetDaysInMonth(jahr_number.value, osm+1)
	cht = himmel
	chm = osm+1
else
	himmel = himmel - timedate1.GetDaysInMonth(jahr_number.value, osm+1)
	cht = himmel
	chm = osm+2
end if

' Fronleichnam
' flt + flm

dim fronl as integer
fronl = ost + 60
fronl = fronl - timedate1.GetDaysInMonth(jahr_number.value, osm)

if fronl < timedate1.GetDaysInMonth(jahr_number.value, osm+1) or fronl = timedate1.GetDaysInMonth(jahr_number.value, osm+1)
	flt = fronl
	flm = osm+1
else
	fronl = fronl - timedate1.GetDaysInMonth(jahr_number.value, osm+1)
	flt = fronl
	flm = osm+2
end if

' Gruendonnerstag - Ostersonntag - 3 Tage - gdt, gdm

gdt = ost - 3
gdm = osm

if gdt < 1
	gdm = gdm-1
	gdt = timedate1.GetDaysInMonth(jahr_number.value, gdm)+gdt
end if


' Karfreitag - Ostersonntag - 2 Tage - kft, kfm

kft = ost - 2
kfm = osm

if kft < 1
	kfm = kfm-1
	kft = timedate1.GetDaysInMonth(jahr_number.value, kfm)+kft
end if

' Aschermittwoch -> Ostersonntag - 46 Tage - at, am

at = ost - 46
am = osm

if at < 1
	am = am-1
	at = at + timedate1.GetDaysInMonth(jahr_number.value, am)
		if at < 1
			am = am-1
			at = at + timedate1.GetDaysInMonth(jahr_number.value, am)
	end if
end if

' Faschingsdienstag - ft, fm

ft = ost - 47
fm = osm

if ft < 1
	fm = fm-1
	ft = ft + timedate1.GetDaysInMonth(jahr_number.value, fm)
		if ft < 1
			fm = fm-1
			ft = ft + timedate1.GetDaysInMonth(jahr_number.value, fm)
	end if
end if

' Rosenmontag - rt, rm

rt = ost - 48
rm = osm

if rt < 1
	rm = rm-1
	rt = rt + timedate1.GetDaysInMonth(jahr_number.value, rm)
		if rt < 1
			rm = rm-1
			rt = rt + timedate1.GetDaysInMonth(jahr_number.value, rm)
	end if
end if

end sub

sub Weihnachten()

' advent1t, advent1m, advent2, advent3, advent4

' Ermittlung des 4. Advents - So vor Weihnachten

dim TagWeihnachten as integer

TagWeihnachten = timedate1.GetDayOfWeek(jahr_number.value, 12, 24)
advent4  = 24 - TagWeihnachten
advent3  = advent4 -  7
advent2  = advent4 - 14
advent1t = advent4 - 21
advent1m = 12

if advent1t < 1
	advent1m = 11
	advent1t = timedate1.GetDaysInMonth(jahr_number.value, 11)+advent1t
end if

' +advent1t deshalb, weil es ja eine negative Zahl ist, die
' abgezogen werden soll

' Totensonntag - 1. Advent - 7 Tage - tst, tsm

tst = advent1t - 7
tsm = advent1m

if tst < 1
	tsm = 11
	tst = timedate1.GetDaysInMonth(jahr_number.value, 11)+tst
end if


' Buss- und Bettag - 1. Advent - 11 Tage - bt, bm

bt = advent1t - 11
bm = advent1m

if bt < 1
	bm = 11
	bt = timedate1.GetDaysInMonth(jahr_number.value, 11)+bt
end if

' Volkstrauertag - 2. Sonntag vor 1. Advent - vt, vm

vt = advent1t - 14
vm = advent1m

if vt < 1
	vm = 11
	vt = timedate1.GetDaysInMonth(jahr_number.value, 11)+vt
end if

' Muttertag - 2. Sonntag im Mai - mt

dim SiebenterMai as integer
SiebenterMai = timedate1.GetDayOfWeek(jahr_number.value, 5, 7)
mt = 7 + (7-SiebenterMai)

' Erntedankfest - So nach 29. September - et / em
' bzw. erster So im Oktober ?

dim TageImSept as integer
dim TagErsterOkt as integer

TagErsterOkt = timedate1.GetDayOfWeek(jahr_number.value, 10, 1)

if TagErsterOkt = 0
	et = 1
	em = 10
else
	et = 7 - TagErsterOkt + 1
	em = 10
end if

end sub

function CorrectString(stelle as string) as string

' correct the timedisplay. "3" -> "03"

if Len(stelle) = 1
	CorrectString = "0"+stelle
else
	CorrectString = stelle
end if

end function

